﻿using System;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;

namespace WindowsFormsApplication45
{
    public partial class Form1 : Form
    {
        Proj4Projection projection = new Proj4Projection();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            winformsMap1.MapClick += new EventHandler<MapClickWinformsMapEventArgs>(winformsMap1_MapClick);
            winformsMap1.MapUnit = GeographyUnit.Meter;
            projection.MemoryMode = Proj4MemoryMode.Unmanaged;
            projection.ExternalProjectionParametersString = UnmanagedProj4Projection.GetGoogleMapParametersString();
            projection.InternalProjectionParametersString = UnmanagedProj4Projection.GetDecimalDegreesParametersString();
            projection.Open();
            winformsMap1.CurrentExtent = projection.ConvertToExternalProjection(new RectangleShape(-155.733, 95.60, 104.42, -81.9));

            GoogleMapsOverlay worldMapKitOverlay = new GoogleMapsOverlay();
            winformsMap1.Overlays.Add(worldMapKitOverlay);

            SimpleMarkerOverlay markerOverlay = new SimpleMarkerOverlay();
            markerOverlay.MapControl = winformsMap1;
            Marker marker = new Marker(projection.ConvertToExternalProjection(new PointShape(27.2909, 75.1929)) as PointShape);
            marker.Width = 20;
            marker.Height = 34;
            marker.YOffset = -17;
            marker.Click += new EventHandler(marker_Click); 
            marker.Image = ProjectionMarkerSample.Properties.Resources.AQUA;
            markerOverlay.Markers.Add(marker);
            winformsMap1.Overlays.Add("MarkerOverlay", markerOverlay);

            winformsMap1.Refresh();
        }

        private void winformsMap1_MapClick(object sender, MapClickWinformsMapEventArgs e)
        {
            SimpleMarkerOverlay markerOverlay = (SimpleMarkerOverlay)winformsMap1.Overlays["MarkerOverlay"];

            Marker marker = new Marker(e.WorldLocation);
            marker.Image = ProjectionMarkerSample.Properties.Resources.AQUA;
            marker.Width = 20;
            marker.Height = 34;
            marker.YOffset = -17;
            marker.Click += new EventHandler(marker_Click);

            markerOverlay.Markers.Add(marker);

            winformsMap1.Refresh();
        }

        void marker_Click(object sender, EventArgs e)
        {
            try
            {

                Marker clickedMarker = sender as Marker;

                PointShape markerLocation = clickedMarker.Position;

            }

            catch (Exception ex)
            {

                MessageBox.Show(ex.Message, "Error");

            }
        }

    }
}
